<template>
  <SfCarousel ref="carousel" class="product-insights-carousel" :settings="options">
    <template #prev="{ go }">
      <SwButton class="product-insights-carousel-carousel-control-prev" @click="go('prev')" >
        <SwGsIconChevronLeft class="dark-secondary size-xs"/>
      </SwButton>
    </template>
    <template #next="{ go }">
      <SwButton class="product-insights-carousel-carousel-control-next" @click="go('next')" >
        <SwGsIconChevronRight class="dark-secondary size-xs"/>
      </SwButton>
    </template>

    <SfCarouselItem
        v-for="(image, index) in images"
        :key="'product-insights-carousel-item-'+ index"
        class="product-insights-carousel-item">
      <SwImage
          class="product-insights-carousel-image"
          :src="image.media.url"
          :alt="image.media.alt ? image.media.alt : 'product-image'"
          :width="imageWidth"
          :height="imageHeight"
      />
    </SfCarouselItem>
  </SfCarousel>
</template>

<script>
import {SfCarousel} from "@storefront-ui/vue";
import SwButton from "@/components/atoms/SwButton.vue";
import SwImage from "@/components/atoms/SwImage.vue";
import {SwGsIconChevronLeft, SwGsIconChevronRight} from "../../icons";

export default {
  name: "InsightsImages",
  components: {
    SfCarousel,
    SwButton,
    SwImage,
    SwGsIconChevronLeft,
    SwGsIconChevronRight,
  },
  props: {
    images: {
      type: [Object,Array],
      default: null,
    },
    imageWidth: {
      type: [Number, String],
      default: 100,
    },
    imageHeight: {
      type: [Number, String],
      default: 100,
    },
  },
  data() {
    return {
      options: {
        perView: 5,
        gap: 5,
        peek: 0,
        breakpoints: {
          1023: {
            perView: 5,
            peek: 0,
          },
        },
      }
    }
  },
  beforeDestroy() {
    if (this.$refs.carousel.glide) {
      this.$refs.carousel.glide.destroy();
    }
  },
}
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  ::v-deep {
    .sf-accordion-item__chevron {
      --chevron-color: var(--c-primary);
      --chevron-size: 16px;
    }

    .sf-carousel__wrapper {
      --carousel-controls-size: 70px;

      .sf-image {
        object-fit: initial;
        height: auto;
        width: 100%;
      }
    }
  }

  .product-insights-carousel {
    margin-top: 12px;
    margin-bottom: 12px;
  }

  .product-insights-carousel-carousel-control-prev,
  .product-insights-carousel-carousel-control-next {
    --button-background: transparent;
    --button-padding: 0;
  }
</style>
